******************************************************************************
* PROGRAM ----: TEST.PRG 
* AUTHOR -----: Kevin E. Saffer 
* COPYRIGHT --: None, placed into the public domain
* CREATED ----: 6/9/1994 at 13:03
******************************************************************************
#include "FiveWin.ch"

STATIC oWnd

*****************************************************************************
FUNCTION Main()
******************************************************************************

  SET 3DLOOK ON
  SET CENTURY ON

  USE patients INDEX patienna

  DEFINE WINDOW oWnd MDI FROM 0, 0 TO 30, 80 ;
    TITLE "KBROWSE DEMONSTATION PROGRAM" ;
    MENU MainMenu()

  SET MESSAGE OF oWnd ;
     TO "WRITTEN BY KEVIN E. SAFFER, OF JACKSONVILLE, FLORIDA" 

  ACTIVATE WINDOW oWnd

  USE

RETURN NIL

******************************************************************************
FUNCTION MainMenu()
******************************************************************************
  LOCAL oMenu

  MENU oMenu

  MENUITEM "&Dialog Browsers" 

    MENU

    MENUITEM "&Small Data File Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A SMALL DIALOG BOX BROWSER WITH A CONTROL." ;
      ACTION DlgFile1()

    MENUITEM "&Full Screen Data File Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A FULL SCREEN DIALOG BOX BROWSER." ;
      ACTION DlgFile2()

    MENUITEM "&Small Array Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A SMALL DIALOG BOX ARRAY BROWSER WITH A CONTROL." ;
      ACTION DlgArray1()

    ENDMENU

  MENUITEM "&Window Browsers" 

    MENU

    MENUITEM "&Small MDI Child Data File Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A SMALL MDI CHILD DATA FILE WINDOW BROWSER." ;
      ACTION WndFile3()

    MENUITEM "&Full Screen MDI Data File Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A FULL SCREEN MDI CHILD DATA FILE WINDOW BROWSER." ;
      ACTION WndFile4()

    MENUITEM "&Small Data File Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A SMALL DATA FILE WINDOW BROWSER." ;
      ACTION WndFile1()

    MENUITEM "&Full Screen Data File Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A SMALL DATA FILE WINDOW BROWSER." ;
      ACTION WndFile2()

    MENUITEM "&Small Array Browse" ;
      MESSAGE "THIS BROWSER DEMONSTRATES A SMALL ARRAY WINDOW BROWSER." ;
      ACTION WndArray1()

    ENDMENU

  MENUITEM "&Quit" ;
    MESSAGE "Stop using this program." ;
    ACTION oWnd:End()

  ENDMENU

RETURN oMenu

******************************************************************************
FUNCTION DlgFile1()
******************************************************************************
  LOCAL oDlg
  LOCAL oBrowse

  SELECT PATIENTS 
  GO TOP

  * create the dialog box first
  DEFINE DIALOG oDlg FROM 70,120 TO 365,496 PIXEL TITLE "Small Dialog Box File Browse"

  * create a dialog browser using the top, left, and right parent coords
  oBrowse := KbDialog():New( oDlg, NIL, NIL, 258, NIL )

  * add a keybown block to hook in an incremental search routine
  oBrowse:bKeyDown := { |nKey, nFlags| FileSearch( oBrowse, nKey, nFlags ) }

  * add the columns
  oBrowse:AddColumn( KbColumn():New( "Patient;Last Name"        , {|| PATIENTS->lastname }  , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( "Patient;First Name"       , {|| PATIENTS->firstname } , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( ";I"                       , {|| PATIENTS->initial }   , NIL, NIL, 1 ) )
                                                                                                         
  * set up a couple of buttons
  @ 11.2, 00.5 BUTTON "&Done"     OF oDlg ACTION oDlg:End()              SIZE 35, 12
  @ 11.2, 06.0 BUTTON "&Font"     OF oDlg ACTION oBrowse:SetNewFont()    SIZE 35, 12

  ACTIVATE DIALOG oDlg

RETURN NIL

******************************************************************************
FUNCTION FileSearch( oBrowse, nKey, nFlags )
******************************************************************************
  STATIC cSeekVar := ""  && holds the current seek string
  LOCAL nRecno

  * check for a space or A-Z
  IF (nKey = 32 .OR. (nKey >= 65 .AND. nKey <= 90)) .AND. .NOT. GetKeyState( VK_CONTROL ) 

    * save current position
    nRecno = RECNO()

    * seek with the new character
    SEEK cSeekVar + UPPER( CHR( nKey ) )

    * check for eof, restore position if so
    IF EOF()
      GO nRecno
    ELSE
      * add the new character to the seek string
      cSeekVar += UPPER( CHR( nKey ) )

      * check to update the browser
      IF RECNO() <> nRecno
        oBrowse:nDataTopElm := RECNO()                && set the topmost displayed record number
        oBrowse:nDataCurElm := oBrowse:nDataTopElm    && set the currently displayed record number
        oBrowse:nCurRowPtr := oBrowse:nDataRowTop     && set the current screen row to the top data area
        oBrowse:DataPaint()                           && repaint the data area
      ENDIF
    ENDIF

    RETURN NIL
  ENDIF

  * any other key clears the seek string
  cSeekVar := ""

RETURN NIL

******************************************************************************
FUNCTION DlgFile2()
******************************************************************************
  LOCAL oDlg
  LOCAL oBrowse

  * same as the previous browser, only bigger with more options
  DEFINE DIALOG oDlg FROM 00,00 TO 450,630 PIXEL TITLE "Large Dialog Box Browse"

  SELECT PATIENTS 
  GO TOP

  oBrowse := KbDialog():New( oDlg, NIL, NIL, 414, NIL )
  oBrowse:bKeyDown := { |nKey, nFlags| FileSearch( oBrowse, nKey, nFlags ) }

  oBrowse:AddColumn( KbColumn():New( "Patient Last Name"        , {|| PATIENTS->lastname }  , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Patient First Name"       , {|| PATIENTS->firstname } , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "I"                        , {|| PATIENTS->initial }   , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "DOB"                      , {|| DTOC(PATIENTS->dob) } , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "SSN"                      , {|| PATIENTS->ssn }       , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Work Telephone"           , {|| PATIENTS->wphone }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Home Telephone"           , {|| PATIENTS->hphone }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Medical Record #"         , {|| PATIENTS->med_rec }   , NIL, NIL, 0 ) ) 
  oBrowse:AddColumn( KbColumn():New( "Facsimile"                , {|| PATIENTS->fax }       , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Primary Insurance Carrier", {|| PATIENTS->pinsur }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Second Insurance Carrier" , {|| PATIENTS->sinsur }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 1"           , {|| PATIENTS->addr1 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 2"           , {|| PATIENTS->addr2 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 3"           , {|| PATIENTS->addr3 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "City"                     , {|| PATIENTS->city }      , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "State"                    , {|| PATIENTS->state }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Zip Code"                 , {|| PATIENTS->zipcode }   , NIL, NIL, 0 ) )
 
  @ 17.6, 00.5 BUTTON "&Done"     OF oDlg ACTION oDlg:End()              SIZE 35, 12
  @ 17.6, 06.0 BUTTON "&Font"     OF oDlg ACTION oBrowse:SetNewFont()    SIZE 35, 12
  @ 17.6, 11.5 BUTTON "Grid &1"   OF oDlg ACTION GridSingle( oBrowse )   SIZE 35, 12
  @ 17.6, 17.0 BUTTON "Grid &2"   OF oDlg ACTION GridDouble( oBrowse )   SIZE 35, 12
  @ 17.6, 22.5 BUTTON "Grid &3"   OF oDlg ACTION Grid3D( oBrowse )       SIZE 35, 12

  ACTIVATE DIALOG oDlg

RETURN NIL

******************************************************************************
FUNCTION GridSingle( oBrowse )
******************************************************************************

  oBrowse:SetFocus()
  oBrowse:SetGrid( 1 )
  oBrowse:BeginPaint()
  oBrowse:Paint()
  oBrowse:EndPaint()

RETURN NIL

******************************************************************************
FUNCTION GridDouble( oBrowse )
******************************************************************************

  oBrowse:SetFocus()
  oBrowse:SetGrid( 2 )
  oBrowse:BeginPaint()
  oBrowse:Paint()
  oBrowse:EndPaint()

RETURN NIL

******************************************************************************
FUNCTION Grid3D( oBrowse )
******************************************************************************

  oBrowse:SetFocus()
  oBrowse:SetGrid( 3 )
  oBrowse:BeginPaint()
  oBrowse:Paint()
  oBrowse:EndPaint()

RETURN NIL

******************************************************************************
FUNCTION DlgArray1()
******************************************************************************
  LOCAL oDlg
  LOCAL oBrowse
  LOCAL aDaysWeek

  * create a two dimentional array to browse
  aDaysWeek := {;
    { "SUNDAY   ", "A well earned Day of rest to prepare for Monday." },;
    { "MONDAY   ", "Ugh!  Absolutely the worst day of the week." },;
    { "TUESDAY  ", "Not a great day, but better than Monday." },;
    { "WEDNESDAY", "Ahh!  Hump Day!  All downhill from here." },;
    { "THURSDAY ", "Excitement builder day for Friday." },;
    { "FRIDAY   ", "TGIF!  LETS PARTY!" },;
    { "SATURDAY ", "Day used to recover from Friday Night." };
  }

  * create the dialog box first
  DEFINE DIALOG oDlg FROM 70,62 TO 365,555 PIXEL TITLE "Small Dialog Box Array Browse"

  * create a dialog browser using the top, left, and right parent coords
  oBrowse := KbDialog():New( oDlg, NIL, NIL, 258, NIL )

  * add a keybown block to hook in a multicolumn incremental search routine
  oBrowse:bKeyDown := { |nKey, nFlags| ArrSearch( oBrowse, nKey, nFlags ) }

  * store a reference to the array into the browser
  oBrowse:Array( aDaysWeek )

  * add the columns, note the code block array references, nArrCurElm must be used!
  oBrowse:AddColumn( KbColumn():New( "Days"             , {|| oBrowse:aReference[ oBrowse:nArrCurElm ][ 1 ] }  , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( "Description"      , {|| oBrowse:aReference[ oBrowse:nArrCurElm ][ 2 ] }  , NIL, NIL, 1 ) )

  * set up a couple of buttons
  @ 11.2, 00.5 BUTTON "&Done"     OF oDlg ACTION oDlg:End()              SIZE 35, 12
  @ 11.2, 06.0 BUTTON "&Font"     OF oDlg ACTION oBrowse:SetNewFont()    SIZE 35, 12

  ACTIVATE DIALOG oDlg

RETURN NIL

******************************************************************************
FUNCTION ArrSearch( oBrowse, nKey, nFlags )
******************************************************************************
  STATIC cSeekVar := ""  && hold the current seek string
  LOCAL nColumn
  LOCAL nResult

  * check for a space or A-Z
  IF (nKey = 32 .OR. (nKey >= 65 .AND. nKey <= 90)) .AND. .NOT. GetKeyState( VK_CONTROL ) 

    * obtain the column the cursor is located in
    nColumn := oBrowse:nCurColPtr

    * scan the array with a block to retrieve the proper column contents
    nResult = ASCAN( oBrowse:aReference, { |m_elm| UPPER( m_elm[ nColumn ] ) = cSeekVar + UPPER( CHR( nKey ) ) } )

    * check for scan success
    IF nResult > 0

      * add the new character to the seek string
      cSeekVar += UPPER( CHR( nKey ) )

      * check to update the browser
      IF nResult <> oBrowse:nArrCurElm
        oBrowse:nArrCurElm := nResult                 && set the internal array pointer
        oBrowse:nDataTopElm := nResult                && set the topmost displayed record number
        oBrowse:nDataCurElm := oBrowse:nDataTopElm    && set the currently displayed record number
        oBrowse:nCurRowPtr := oBrowse:nDataRowTop     && set the current screen row to the top data area
        oBrowse:DataPaint()                           && repaint the data area
      ENDIF
    ENDIF

    RETURN NIL
  ENDIF

  * any other key clears the seek string
  cSeekVar := ""

RETURN NIL

******************************************************************************
FUNCTION WndFile1()
******************************************************************************
  LOCAL oBrowse

  SELECT PATIENTS 
  GO TOP

  oBrowse := KbWindow():New( 70, 115, 356, 496, "Small Window Data File Browser")
  oBrowse:bKeyDown := { |nKey, nFlags| FileSearch( oBrowse, nKey, nFlags ) }

  oBrowse:AddColumn( KbColumn():New( "Patient;Last Name"        , {|| PATIENTS->lastname }  , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( "Patient;First Name"       , {|| PATIENTS->firstname } , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( ";I"                       , {|| PATIENTS->initial }   , NIL, NIL, 1 ) )
                                                                                                         
  ACTIVATE WINDOW oBrowse

RETURN NIL

******************************************************************************
FUNCTION WndFile2()
******************************************************************************
  LOCAL oBrowse

  SELECT PATIENTS 
  GO TOP

  oBrowse := KbWindow():New( 0, 0, 479, 639, "Full Screen Window Data File Browser")
  oBrowse:bKeyDown := { |nKey, nFlags| FileSearch( oBrowse, nKey, nFlags ) }

  oBrowse:AddColumn( KbColumn():New( "Patient Last Name"        , {|| PATIENTS->lastname }  , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Patient First Name"       , {|| PATIENTS->firstname } , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "I"                        , {|| PATIENTS->initial }   , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "DOB"                      , {|| DTOC(PATIENTS->dob) } , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "SSN"                      , {|| PATIENTS->ssn }       , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Work Telephone"           , {|| PATIENTS->wphone }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Home Telephone"           , {|| PATIENTS->hphone }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Medical Record #"         , {|| PATIENTS->med_rec }   , NIL, NIL, 0 ) ) 
  oBrowse:AddColumn( KbColumn():New( "Facsimile"                , {|| PATIENTS->fax }       , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Primary Insurance Carrier", {|| PATIENTS->pinsur }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Second Insurance Carrier" , {|| PATIENTS->sinsur }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 1"           , {|| PATIENTS->addr1 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 2"           , {|| PATIENTS->addr2 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 3"           , {|| PATIENTS->addr3 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "City"                     , {|| PATIENTS->city }      , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "State"                    , {|| PATIENTS->state }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Zip Code"                 , {|| PATIENTS->zipcode }   , NIL, NIL, 0 ) )

  ACTIVATE WINDOW oBrowse

RETURN NIL

******************************************************************************
FUNCTION WndFile3()
******************************************************************************
  LOCAL oBrowse

  SELECT PATIENTS 
  GO TOP

  oBrowse := KbMChild():New( oWnd, 70, 115, 356, 496, "Small MDI Window File Browser")
  oBrowse:bKeyDown := { |nKey, nFlags| FileSearch( oBrowse, nKey, nFlags ) }

  oBrowse:AddColumn( KbColumn():New( "Patient;Last Name"        , {|| PATIENTS->lastname }  , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( "Patient;First Name"       , {|| PATIENTS->firstname } , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( ";I"                       , {|| PATIENTS->initial }   , NIL, NIL, 1 ) )
                                                                                                         
  ACTIVATE WINDOW oBrowse

RETURN NIL

******************************************************************************
FUNCTION WndFile4()
******************************************************************************
  LOCAL oBrowse

  SELECT PATIENTS 
  GO TOP

  oBrowse := KbMChild():New( oWnd, 10, 10, 400, 620, "Full Screen MDI Window Data File Browser")
  oBrowse:bKeyDown := { |nKey, nFlags| FileSearch( oBrowse, nKey, nFlags ) }

  oBrowse:AddColumn( KbColumn():New( "Patient Last Name"        , {|| PATIENTS->lastname }  , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Patient First Name"       , {|| PATIENTS->firstname } , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "I"                        , {|| PATIENTS->initial }   , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "DOB"                      , {|| DTOC(PATIENTS->dob) } , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "SSN"                      , {|| PATIENTS->ssn }       , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Work Telephone"           , {|| PATIENTS->wphone }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Home Telephone"           , {|| PATIENTS->hphone }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Medical Record #"         , {|| PATIENTS->med_rec }   , NIL, NIL, 0 ) ) 
  oBrowse:AddColumn( KbColumn():New( "Facsimile"                , {|| PATIENTS->fax }       , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Primary Insurance Carrier", {|| PATIENTS->pinsur }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Second Insurance Carrier" , {|| PATIENTS->sinsur }    , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 1"           , {|| PATIENTS->addr1 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 2"           , {|| PATIENTS->addr2 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Address Line 3"           , {|| PATIENTS->addr3 }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "City"                     , {|| PATIENTS->city }      , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "State"                    , {|| PATIENTS->state }     , NIL, NIL, 0 ) )
  oBrowse:AddColumn( KbColumn():New( "Zip Code"                 , {|| PATIENTS->zipcode }   , NIL, NIL, 0 ) )
                                                                                                         
  ACTIVATE WINDOW oBrowse

RETURN NIL

******************************************************************************
FUNCTION WndArray1()
******************************************************************************
  LOCAL oBrowse
  LOCAL aDaysWeek

  * create, and store a reference to the array into the browser
  aDaysWeek := {;
    { "SUNDAY   ", "A well earned Day of rest to prepare for Monday." },;
    { "MONDAY   ", "Ugh!  Absolutely the worst day of the week." },;
    { "TUESDAY  ", "Not a great day, but better than Monday." },;
    { "WEDNESDAY", "Ahh!  Hump Day!  All downhill from here." },;
    { "THURSDAY ", "Excitement builder day for Friday." },;
    { "FRIDAY   ", "TGIF!  LETS PARTY!" },;
    { "SATURDAY ", "Day used to recover from Friday Night." };
  }

  oBrowse := KbMChild():New( oWnd, 70, 55, 356, 555, "Small MDI Array Browser")
  oBrowse:bKeyDown := { |nKey, nFlags| ArrSearch( oBrowse, nKey, nFlags ) }
  oBrowse:Array( aDaysWeek )

  oBrowse:AddColumn( KbColumn():New( "Days"             , {|| oBrowse:aReference[ oBrowse:nArrCurElm ][ 1 ] }  , NIL, NIL, 1 ) )
  oBrowse:AddColumn( KbColumn():New( "Description"      , {|| oBrowse:aReference[ oBrowse:nArrCurElm ][ 2 ] }  , NIL, NIL, 1 ) )
                                                                                                         
  ACTIVATE WINDOW oBrowse

RETURN NIL


